apiVersion: v1
kind: ConfigMap
metadata:
  name: turbo-config
data:
  odoo.conf: |
    [options]
    addons_path = /odoo-addons
    data_dir = /var/lib/odoo
    ; admin_passwd = admin
    ; csv_internal_sep = ,
    ; db_maxconn = 64
    ; db_template = template1
    ; debug_mode = False
    email_from = "noreply@epfl.ch"
    limit_memory_hard = 4294967296
    limit_memory_soft = 4000000000
    limit_request = 8192
    limit_time_cpu = 600
    limit_time_real = 1200
    ; list_db = True
    ; log_db = False
    ; log_handler = [':INFO']
    ; log_level = info
    ; logfile = None
    ; longpolling_port = 8072
    ; osv_memory_age_limit = 1.0
    ; osv_memory_count_limit = False
    smtp_password = False
    smtp_port = 25
    smtp_server = mail.epfl.ch
    smtp_ssl = False
    smtp_user = False
    workers = 8
    max_cron_threads = 2
    xmlrpc = True
    ; xmlrpc_interface = 
    xmlrpc_port = 8070
    ; xmlrpcs = True
    ; xmlrpcs_interface = 
    ; xmlrpcs_port = 8071
    proxy_mode = True
    fintech_register_name = 
    fintech_register_keycode = 
    fintech_register_users = 
    server_wide_modules = web,queue_job

  nginx.conf: |
    # HTTP context
    proxy_buffering on;
    proxy_cache_path /var/lib/nginx/cache levels=1:2 keys_zone=odoocache:10m max_size=1g;

    server {
        listen [::]:8069;
        listen 8069;

        client_max_body_size 100M;

        real_ip_header X-Real-IP;
        real_ip_recursive on;

        proxy_busy_buffers_size   1024k;
        proxy_buffers   4 1024k;
        proxy_buffer_size   512k;

        proxy_read_timeout 1200;
        proxy_connect_timeout 1200;
        proxy_send_timeout 1200;

        location /longpolling {
            proxy_set_header Host $http_host;
            proxy_set_header X-Real-IP $http_x_real_ip;
            proxy_pass http://localhost:8072;
        }

        location ^/web/dataset/call_kw {
            proxy_cache odoocache;
            proxy_cache_key "$request_uri|$request_body";
            proxy_cache_methods POST;
            proxy_ignore_headers Vary; # Set-Cookie;
            proxy_hide_header Cache-Control;
            add_header Agep-Odoo-Cache "$host$request_uri$cookie_user";
            add_header X-Proxy-Cache $upstream_cache_status;

            ## Naive enforcing of cache-control
            # proxy_hide_header Set-Cookie;
            # add_header 'Cache-Control' "public, max-age=86400";

            proxy_set_header Host $http_host;
            proxy_set_header X-Real-IP $http_x_real_ip;
            proxy_pass http://localhost:8070;
        }

        location / {
            proxy_set_header Host $http_host;
            proxy_set_header X-Real-IP $http_x_real_ip;
            proxy_pass http://localhost:8070;
        }
    }
